; find out hardware map
HWN I
:query_loop
SUB I, 1
HWQ I
IFE B, 0x7349
  IFE A, 0xf615
    SET [monitor_n], I
IFE B, 0x30cf
  IFE A, 0x7406
    SET [keyboard_n], I
IFE B, 0x12d0
  IFE A, 0xb402
    SET [clock_n], I
IFN I, 0
  SET PC, query_loop

; print labels
SET A, info_str
SET I, 0
JSR printstr
SET A, labels_str
SET I, 0x60
JSR printstr

; set up monitor
SET A, 0
SET B, 0x8000
HWI [monitor_n]

; set up keyboard
SET A, 3
SET B, 1
HWI [keyboard_n]

; set up clock
SET A, 2
SET B, 2
HWI [clock_n]

SET X, 0

; enable interrupts
IAS int_handler

; initialize text fields with software int
INT 1
; wait
SUB PC, 1

:int_handler
IFE A, 1  ; keyboard
  SET PC int_handler_kb
IFE A, 2  ; clock
  SET PC int_handler_clock
SET PC, int_handler_end
:int_handler_kb
; get pressed key:
SET A, 1
HWI [keyboard_n]
IFE C, 0x61
  ADD X, 1
IFE C, 0x7a
  SUB X, 1
; update timer divisor
SET A, 0
SET B, X
HWI [clock_n]
; print timer divisor
SET A, X
SET I, 0xa0
JSR printdec
;SET PC, int_handler_end
:int_handler_clock
; print counter
SET A, 1
HWI [clock_n]
SET A, C
SET I, 0xb0
JSR printdec
SET PC, int_handler_end
:int_handler_end
RFI 0


; print decimal number A to location I
:printdec
SET PUSH, A
SET PUSH, B
SET PUSH, I
SET PUSH, J
SET J, I
SUB J, 1
ADD I, 4
:printdec_l1
SET B, A
MOD B, 10
ADD B, 0xf030
SET [0x8000+I], B
DIV A, 10
SUB I, 1
IFN I, J
  SET PC, printdec_l1
SET J, POP
SET I, POP
SET B, POP
SET A, POP
SET PC, POP


; print hexadecimal number A to location I
:printhex
SET PUSH, A
SET PUSH, B
SET PUSH, I
SET PUSH, J
SET J, I
SUB J, 1
ADD I, 3
:printhex_l1
SET B, A
AND B, 0x0f
IFG B, 9
  ADD B, 7
ADD B, 0xf030
SET [0x8000+I], B
SHR A, 4
SUB I, 1
IFN I, J
  SET PC, printhex_l1
SET J, POP
SET I, POP
SET B, POP
SET A, POP
SET PC, POP


; print zero-terminated string at A to location I
:printstr
SET PUSH, A
SET PUSH, B
SET PUSH, I
:printstr_loop
SET B, [A]
IFE B, 0
  SET PC, printstr_end
BOR B, 0xf000
SET [0x8000+I], B
ADD A, 1
ADD I, 1
SET PC, printstr_loop
:printstr_end
SET I, POP
SET B, POP
SET A, POP
SET PC, POP


:monitor_n
DAT 0
:keyboard_n
DAT 0
:clock_n
DAT 0

:info_str
DAT "Press A/Z to change divisor.", 0
:labels_str
DAT "Divisor:        Counter:", 0
