; find out hardware map
HWN I
:query_loop
SUB I, 1
HWQ I
IFE B, 0x7349
  IFE A, 0xf615
    SET [monitor_n], I
IFE B, 0x30cf
  IFE A, 0x7406
    SET [keyboard_n], I
IFE B, 0x12d0
  IFE A, 0xb402
    SET [clock_n], I
IFE B, 0x0206
  IFE A, 0x0001
    SET [spkr_n], I
IFN I, 0
  SET PC, query_loop

; set up monitor
SET A, 0
SET B, 0x8000
HWI [monitor_n]
; blue border
SET A, 3
SET B, 0x1
HWI [monitor_n]

; set up keyboard
SET A, 3
SET B, [keyboard_n]
HWI [keyboard_n]

; print text
SET A, 0xf000
SET I, text1
SET J, 0x8022
JSR putstr
SET I, text2
SET J, 0x806a
JSR putstr

; enable interrupts
IAS int_handler

SET I, 0x0064
SET A, 0
JSR printdec
SUB PC, 1

:int_handler
SET A, 1
HWI [keyboard_n]
SET B, 0
; I: freq table index
SET I, -1
; check top row
IFE C, 0x71
  SET I, 0x8000
IFE C, 0x32
  SET I, 0x8001
IFE C, 0x77
  SET I, 0x8002
IFE C, 0x33
  SET I, 0x8003
IFE C, 0x65
  SET I, 0x8004
IFE C, 0x72
  SET I, 0x8005
IFE C, 0x35
  SET I, 0x8006
IFE C, 0x74
  SET I, 0x8007
IFE C, 0x36
  SET I, 0x8008
IFE C, 0x79
  SET I, 0x8009
IFE C, 0x37
  SET I, 0x800a
IFE C, 0x75
  SET I, 0x800b
IFE C, 0x69
  SET I, 0x800c
; check bottom row
IFE C, 0x7a
  SET I, 12
IFE C, 0x73
  SET I, 13
IFE C, 0x78
  SET I, 14
IFE C, 0x64
  SET I, 15
IFE C, 0x63
  SET I, 16
IFE C, 0x76
  SET I, 17
IFE C, 0x67
  SET I, 18
IFE C, 0x62
  SET I, 19
IFE C, 0x68
  SET I, 20
IFE C, 0x6e
  SET I, 21
IFE C, 0x6a
  SET I, 22
IFE C, 0x6d
  SET I, 23
IFE C, 0x2c
  SET I, 24
IFE I, -1
  SET PC, int_handler_nosound
ADD I, 12
; check for ctrl
SET A, 2
SET B, 0x91
HWI [keyboard_n]
IFN C, 0
  IFC I, 0x8000
    ADD I, 12
IFN C, 0
  IFB I, 0x8000
    SUB I, 12
AND I, 0x0fff
SET B, [freq_table+I]
:int_handler_nosound
SET A, 0
HWI [spkr_n]
SET A, B
SET I, 0x0064
JSR printdec
RFI 0


; print decimal number A to location I
:printdec
SET PUSH, A
SET PUSH, B
SET PUSH, I
SET PUSH, J
SET J, I
SUB J, 1
ADD I, 4
:printdec_l1
SET B, A
MOD B, 10
ADD B, 0xf030
SET [0x8000+I], B
DIV A, 10
SUB I, 1
IFN I, J
  SET PC, printdec_l1
SET J, POP
SET I, POP
SET B, POP
SET A, POP
SET PC, POP


; print zero-terminated string from [I] to [J] using color in A
:putstr
SET PUSH, B
SET PUSH, I
SET PUSH, J
:putstr_loop
SET B, [I]
IFE B, 0
  SET PC, putstr_end
BOR B, A
STI [J], B
SET PC, putstr_loop
:putstr_end
SET J, POP
SET I, POP
SET B, POP
SET PC, POP


:freq_table  ; half-tone steps
; C2 -> C3
DAT  64,  69,  73,  78,  82,  87,  92,  98, 104, 110, 117, 123
; C3 -> B3
DAT 131, 139, 147, 156, 165, 175, 185, 196, 208, 220, 233, 247
; C4 -> B4
DAT 262, 277, 294, 311, 330, 349, 370, 392, 415, 440, 466, 494
; C5 -> B5
DAT 523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988
; C6
DAT 1047

:text1
DAT "Current frequency:", 0
:text2
DAT "Hz", 0


:monitor_n
DAT 0
:keyboard_n
DAT 0
:clock_n
DAT 0
:spkr_n
DAT 0
