; find out hardware map
HWN I
:query_loop
SUB I, 1
HWQ I
IFE B, 0x7349
  IFE A, 0xf615
    SET [monitor_n], I
IFE B, 0x30cf
  IFE A, 0x7406
    SET [keyboard_n], I
IFN I, 0
  SET PC, query_loop

; set up monitor
SET A, 0
SET B, 0x8000
HWI [monitor_n]

; dark gray border
SET A, 3
SET B, 0x8
HWI [monitor_n]
; print intro
SET A, intro_text
SET C, 0xf800
SET B, 0x8000
JSR putline
SET C, 0x0700
SET B, 0x8020
JSR putline
SET C, 0xf000
SET B, 0x8040
JSR putline
SET B, 0x8060
JSR putline
SET B, 0x8080
JSR putline
SET C, 0x0700
SET B, 0x80c0
JSR putline
SET C, 0xf000
SET B, 0x80e0
JSR putline
SET B, 0x8100
JSR putline
SET B, 0x8120
JSR putline
SET C, 0x7000
SET B, 0x8160
JSR putline

; make font
SET I, 0
:font_loop
SET A, I
SET C, 0
SET J, 8
:bit_loop
SHL C, 2
IFC A, 0x80
  SET PC, bit_loop_it
BOR C, 0x3
:bit_loop_it
SHL A, 1
SUB J, 1
IFG J, 0
  SET PC, bit_loop
SET A, C
AND C, 0xff
SET B, C
SHL C, 8
BOR B, C
SET J, I
SHL J, 1
SET [0x9000+J], B
SHR A, 8
SET B, A
SHL A, 8
BOR B, A
SET [0x9001+J], B
ADD I, 1
IFL I, 0x80
  SET PC, font_loop

; wait for key press
SET A, 1
:keywait_loop
HWI [keyboard_n]
IFE C, 0
  SET PC, keywait_loop

; clear intro text
SET Z, 0x8000
JSR clearscr
; black border
SET A, 3
SET B, 0x0
HWI [monitor_n]

; custom font map
SET A, 1
SET B, 0x9000
HWI [monitor_n]

; set up keyboard
SET A, 3
SET B, 1  ; msg: 1
HWI [keyboard_n]

; set cursor showing drawing area
SET Z, 0x8200

; enable interrupts
IAS int_handler


; MAIN
; start in the center
SET I, 32
SET J, 24
; initialize flags
SET Y, 0x00  ; 0000 000d  d: drawing

SUB PC, 1


:int_handler
SET A, 1
HWI [keyboard_n]

IFN A, 1
  SET PC, int_handler_notkb
; check where to move cursor
SET A, 2
SET B, 0x80  ; up
HWI [keyboard_n]
IFN C, 0
  SUB J, 1
SET B, 0x81  ; down
HWI [keyboard_n]
IFN C, 0
  ADD J, 1
SET B, 0x82  ; left
HWI [keyboard_n]
IFN C, 0
  SUB I, 1
SET B, 0x83  ; right
HWI [keyboard_n]
IFN C, 0
  ADD I, 1
; special commands
SET B, 0x20  ; space
HWI [keyboard_n]
IFN C, 0
  XOR Y, 0x01
SET B, 0x91  ; ctrl for "show cursor position"
HWI [keyboard_n]
IFE C, 0
  SET PC, int_handler_draw_usual
; draw only current cursor position
JSR putpixel
JSR flipscr
SET C, 0x1  ; from here on, C contains the border color
SET PC, int_handler_finish
:int_handler_draw_usual
SET A, 0
SET B, 0x8000
HWI [monitor_n]
SET C, 0x0
:int_handler_finish
; clear keyboard buffer
SET A, 0
HWI [keyboard_n]
IFC Y, 0x01
  SET PC, int_handler_notdrawing
SET PUSH, Z
SET Z, 0x8000
JSR putpixel
SET Z, POP
; make border bright
BOR C, 0x8
:int_handler_notdrawing
:int_handler_notkb
; draw border
SET A, 3
SET B, C
HWI [monitor_n]
RFI 0


; puts a pixel to location (I,J) using screen map at Z
:putpixel
SET PUSH, A
SET PUSH, B
SET PUSH, I
SET PUSH, J
SET PUSH, X
SET PUSH, Y
SET PUSH, Z
; character coords:
SET X, I
SET Y, J
SHR X, 1
SHR Y, 2
SHL Y, 5
ADD X, Y
ADD Z, X
; find out character index
AND I, 0x1
AND J, 0x3
SET A, 1
SHL A, J
SHL I, 2
SHL A, I

SET B, [Z]
BOR A, 0xf000
IFB A, 0x80
  SET PC, putpixel_haslastpixel
SET PC, putpixel_nolastpixel
:putpixel_haslastpixel
IFC B, 0x0f00
  XOR B, 0xff7f
AND B, 0x0fff
SET PC, putpixel_draw
:putpixel_nolastpixel
IFB B, 0x0f00
  SET PC, putpixel_oldlastpixel
BOR B, A
SET PC, putpixel_draw
:putpixel_oldlastpixel
XOR A, 0xff7f
AND B, A
SET PC, putpixel_draw
:putpixel_draw
SET [Z], B
SET Z, POP
SET Y, POP
SET X, POP
SET J, POP
SET I, POP
SET B, POP
SET A, POP
SET PC, POP


; clear screen mapped to Z
:clearscr
SET PUSH, I
SET PUSH, Z
SET I, Z
ADD Z, 0x180
:clearscr_loop
SET [I], 0
ADD I, 1
IFL I, Z
  SET PC, clearscr_loop
SET Z, POP
SET I, POP
SET PC, POP


; switch to other screen buffer in Z (0x8200 <-> 0x8600) and clear new screen
:flipscr
SET PUSH, A
SET PUSH, B
SET A, 0
SET B, Z
HWI [monitor_n]
XOR Z, 0x0400
JSR clearscr
SET B, POP
SET A, POP
SET PC, POP


; writes zero-terminated line from A to B with color in high 9 bits of C;
; leaves zeroaddress+1 in A and next destination address in B
:putline
SET PUSH, C
AND C, 0xff70
:putstr_loop
SET X, [A]
IFE X, 0
  SET PC, putstr_end
BOR X, C
SET [B], X
ADD A, 1
ADD B, 1
SET PC, putstr_loop
:putstr_end
ADD A, 1
SET C, POP
SET PC, POP


:monitor_n
DAT 0
:keyboard_n
DAT 0

:intro_text
DAT "       ---   SKETCH   ---       ", 0
DAT " CONTROLS                       ", 0
DAT "  Arrows:  Control cursor", 0
DAT "  Space:   Toggle drawing", 0
DAT "  Control: Show cursor position", 0
DAT " BORDER CODES                   ", 0
DAT "  Dark:    Not drawing", 0
DAT "  Bright:  Drawing", 0
DAT "  Blue:    Showing position", 0
DAT "Press any key to start.", 0
